import numpy as np
from sklearn import preprocessing

D = np.loadtxt( "banana.csv", delimiter=',') 
print( D.shape )


minmax = preprocessing.MinMaxScaler( feature_range=[-1.0, 1.0]  )

minmax.fit( D[:,0:2] )

X = minmax.transform( D[:,0:2] )
print( X.shape )

S = np.concatenate( (X, D[:,2].reshape(-1,1) ), axis=1 )
print( S.shape )

np.savetxt( "banMinMax.csv", S, delimiter=',', fmt=['%.6e', '%.6e', '%1d'] )


